from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from OpenGL.GL.ARB.multitexture import *
import sys
from LinearAlgebra import *
from Numeric import *
from Effect import *

x = 0
y = 0
x2= 0
y2= 0

effect = None

cube_pos = []
cube_normal = []
cube_uvs = []
cube_tangent = []
cube_binormal = []

def init(): 
	global effect
	global cube_pos
        global cube_normal
        global cube_uvs
        global cube_tangent
        global cube_binormal
	

        #Init effect  
	#effect = Effect(filename = "bumpreflectcg.fx", cubeMap = "nvlobby_cube_mipmap.dds", normalMap = "default_bump_normal.dds")
       
	
	
	mat_specular = ( 1.0, 1.0, 1.0, 1.0 )
	mat_shininess = ( 50.0 )
	light_position = ( 5.0, 5.0, 0.0, 0.0 )
	
	light_ambient = ( 0.0, 0.0, 0.0, 1.0 )
	light_diffuse = ( 1.0, 1.0, 1.0, 1.0 )
	light_specular = ( 1.0, 1.0, 1.0, 1.0 )
	
	
	glLightfv (GL_LIGHT0, GL_AMBIENT, light_ambient)
	glLightfv (GL_LIGHT0, GL_DIFFUSE, light_diffuse)
	glLightfv (GL_LIGHT0, GL_SPECULAR, light_specular)
	glLightfv (GL_LIGHT0, GL_POSITION, light_position)
	
	glClearColor (0.2, 0.2, 0.2, 0.0)
	glShadeModel (GL_SMOOTH)

	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular)
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess)
	glLightfv(GL_LIGHT0, GL_POSITION, light_position)
	
	glEnable(GL_LIGHTING)
	glEnable(GL_LIGHT0)
	glEnable(GL_DEPTH_TEST)
	glEnable(GL_NORMALIZE)

        if not glInitMultitextureARB():
            print "Help!  No GL_ARB_multitexture"
            sys.exit(1)


	cube_pos = array([
	 [-2.0, -2.0,  2.0, 1.0],
	 [-2.0,  2.0,  2.0, 1.0],
	 [2.0,  2.0,  2.0, 1.0],
	 [2.0, -2.0,  2.0, 1.0],

	#Back face
	 [2.0, -2.0, -2.0, 1.0],
	 [2.0,  2.0, -2.0, 1.0],
	 [-2.0,  2.0, -2.0, 1.0],
	 [-2.0, -2.0, -2.0, 1.0],

	#Top face.
	 [-2.0,  2.0,  2.0, 1.0],
	 [-2.0,  2.0, -2.0, 1.0],
	 [2.0,  2.0, -2.0, 1.0],
	 [2.0,  2.0,  2.0, 1.0],

	#Bottom face.
	 [-2.0,  -2.0, -2.0, 1.0],
	 [-2.0,  -2.0,  2.0, 1.0],
	 [2.0,  -2.0,  2.0, 1.0],
	 [2.0,  -2.0, -2.0, 1.0],


	#Right side.
	 [2.0, -2.0,  2.0, 1.0],
	 [2.0,  2.0,  2.0, 1.0],
	 [2.0,  2.0, -2.0, 1.0],
	 [2.0, -2.0, -2.0, 1.0],

	#Left side.
	 [-2.0, -2.0, -2.0, 1.0],
	 [-2.0,  2.0, -2.0, 1.0],
	 [-2.0,  2.0,  2.0, 1.0],
	 [-2.0, -2.0,  2.0, 1.0]])

	cube_normal = [
	#Front face.
	( 0.0, 0.0, 1.0),
	( 0.0, 0.0, 1.0),
	( 0.0, 0.0, 1.0),
	( 0.0, 0.0, 1.0),

	#Back face.
	( 0.0, 0.0, -1.0),
	( 0.0, 0.0, -1.0),
	( 0.0, 0.0, -1.0),
	( 0.0, 0.0, -1.0),

	#Top face.
	( 0.0, 1.0, 0.0),
	( 0.0, 1.0, 0.0),
	( 0.0, 1.0, 0.0),
	( 0.0, 1.0, 0.0),

	#Bottom face.
	( 0.0, -1.0, 0.0),
	( 0.0, -1.0, 0.0),
	( 0.0, -1.0, 0.0),
	( 0.0, -1.0, 0.0),

	#right side.
	( 1.0, 0.0, 0.0),
	( 1.0, 0.0, 0.0),
	( 1.0, 0.0, 0.0),
	( 1.0, 0.0, 0.0),

	#Left side.
	( -1.0, 0.0, 0.0),
	( -1.0, 0.0, 0.0),
	( -1.0, 0.0, 0.0),
	( -1.0, 0.0, 0.0)]


        cube_uvs = [
	#Front face
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	),

	#Back face
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	),

	#Top face.
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	),

	#Bottom face.
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	),

	#Right Side face.
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	),

	#left Side face.
	(	0.0, 1.0	),
	(	0.0, 0.0	),
	(	1.0, 0.0	),
	(	1.0, 1.0	)]

        cube_tangent = [(0.0,0.0,0.0)]*24

        cube_binormal = [(0.0,0.0,0.0)]*24

        for i in range(6):
	
		vec1 = (cube_pos[(i*4)+2][0] - cube_pos[(i*4)+0][0],
                        cube_pos[(i*4)+2][1] - cube_pos[(i*4)+0][1],
		        cube_pos[(i*4)+2][2] - cube_pos[(i*4)+0][2])

		vec2 = (cube_pos[(i*4)+1][0] - cube_pos[(i*4)+0][0],
		        cube_pos[(i*4)+1][1] - cube_pos[(i*4)+0][1],
		        cube_pos[(i*4)+1][2] - cube_pos[(i*4)+0][2])


		d_u1 = cube_uvs[(i*4)+2][0] - cube_uvs[(i*4)+0][0]
		d_u2 = cube_uvs[(i*4)+1][1] - cube_uvs[(i*4)+0][1]


		cube_tangent[(i*4)+0] = ( (d_u1 * vec1[0]) - (d_u2 * vec2[0]),
		                          (d_u1 * vec1[1]) - (d_u2 * vec2[1]),
		                          (d_u1 * vec1[2]) - (d_u2 * vec2[2]) )

		##Normalize.
		mag = (cube_tangent[(i*4)+0][0] * cube_tangent[(i*4)+0][0]) + (cube_tangent[(i*4)+0][1] * cube_tangent[(i*4)+0][1]) + (cube_tangent[(i*4)+0][2] * cube_tangent[(i*4)+0][2]);
		mag = 1.0 / sqrt(mag);

		cube_tangent[(i*4)+0] = ( mag*cube_tangent[(i*4)+0][0],
                                          mag*cube_tangent[(i*4)+0][1],
                                          mag*cube_tangent[(i*4)+0][2] )


		##For a cube, all other verts per face share the same values!
		for j in range(1,4):
			cube_tangent[(i*4)+j] = (cube_tangent[(i*4)+0][0],
                                                 cube_tangent[(i*4)+0][1],
                                                 cube_tangent[(i*4)+0][2])


	##The binormal is the cross product of the normal and tangent.
	for i in range(24):
    		cube_binormal[i] = ((cube_normal[i][1] * cube_tangent[i][2]) - (cube_normal[i][2] * cube_tangent[i][1]),
                                    (cube_normal[i][2] * cube_tangent[i][0]) - (cube_normal[i][0] * cube_tangent[i][2]),
                                    (cube_normal[i][0] * cube_tangent[i][1]) - (cube_normal[i][1] * cube_tangent[i][0]))
	
       
def display():
	global x,x2
	global y,y2
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	#move camera
	glMatrixMode(GL_MODELVIEW)
	#glRotatef(0.3,0.2,0,0)
	glRotatef(0.3,0.6,0.6,0)

	#effect.
	#effect.toonshade = glGetFloatv(GL_MODELVIEW_MATRIX)
	#effect.SetMatrices(ModelMatrix, glGetFloatv(GL_MODELVIEW_MATRIX), glGetFloatv(GL_PROJECTION_MATRIX))
	
	glPushAttrib(GL_ALL_ATTRIB_BITS)
	passes = effect.Begin()
	for p in range(passes):
		effect.Pass(p)
		#glutSolidTeapot(1.0)
		drawCube()
		#glutSolidSphere (2.0, 40, 40)
	effect.End()
	glPopAttrib()
	
	
	
	#draw teapot without effect
	#glPushMatrix()
	#glMatrixMode(GL_MODELVIEW)
	#glTranslatef(0.0,1.7,0.0)
	#glutSolidTeapot(1.0)
	#glutSolidSphere (3.0, 40, 40)
	#glPopMatrix()
	
	glutSwapBuffers()



def drawCube():

        global cube_pos
        global cube_normal
        global cube_uvs
        global cube_tangent
        global cube_binormal

        glEnableClientState( GL_VERTEX_ARRAY)
	glEnableClientState( GL_NORMAL_ARRAY )
	glEnableClientState( GL_TEXTURE_COORD_ARRAY )
	
	#glVertexPointer(4,GL_FLOAT , 0, cube_pos.tostring())
	glVertexPointerf(cube_pos)
	

        #try:
        #glNormalPointer(GL_FLOAT,12,cube_normal)
        glNormalPointerf(cube_normal)
        glClientActiveTextureARB(GL_TEXTURE0_ARB)
        glTexCoordPointer(2,GL_FLOAT,8,cube_uvs)
        glTexCoordPointerf(cube_uvs)
	
        ## tangents:
        glClientActiveTextureARB(GL_TEXTURE1_ARB)
        glEnableClientState(GL_TEXTURE_COORD_ARRAY)
        #glTexCoordPointer(3,GL_FLOAT,12,cube_tangent)
        glTexCoordPointerf(cube_tangent)
	
        ## binormals
        glClientActiveTextureARB(GL_TEXTURE2_ARB)
        glEnableClientState(GL_TEXTURE_COORD_ARRAY)
        #glTexCoordPointer(3,GL_FLOAT,12,cube_binormal)
        glTexCoordPointerf(cube_binormal)

        glClientActiveTextureARB(GL_TEXTURE0_ARB)

        ##Draw the whole cube!
        glDrawArrays(GL_QUADS, 0, 24)
        #glutSolidTeapot(0.5)
        #except Exception,e:
         #   print "ERROR: %s" % e
	


def reshape (w, h):
	glViewport (0, 0, w, h)
	glMatrixMode (GL_PROJECTION)
	glLoadIdentity()
	glFrustum(-8/6.0,8/6.0,-1,1,1,30)
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glTranslatef(0,0,-6);

	

def keyboard(key, x, y):
	if key=='r':
		reload(SimpleEffectTex)
	if key=='q' or key=='Q':
		sys.exit(0)


glutInit(sys.argv)
glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_ALPHA | GLUT_DEPTH)
glutInitWindowSize (500, 500)
glutInitWindowPosition (100, 100)
glutCreateWindow ("Simple Python OpenGL CgFX Effect")
init ()
glutDisplayFunc(display)
glutReshapeFunc(reshape)
glutKeyboardFunc(keyboard)
glutIdleFunc(display)
glutMainLoop()


